coalator<-function(n=12, scale=TRUE, pdf=FALSE) {
    ## This function draws coalescent trees

  if(pdf) pdf(file = "tree%02d.pdf", width=36, height=24, family="Times", pointsize=.1, horizontal=FALSE, onefile=FALSE)

  coal<-matrix(nrow=2*n-1,ncol=2)
  coal2<-matrix(nrow=2*n-1,ncol=2)

  coal[1,1]<-0
  if(n>2) for(i in 2:(n-1)) coal[i,1] <- coal[i-1,1] + rexp(1,i*(i-1)/2)
  tTotal<-coal[n-1,1]+rexp(1,n*(n-1)/2)
  for(i in n:(2*n-1)) {
    coal[i,1]<-tTotal
    coal[i,2]<-i-n+.5
  }

  plot(x=c(0,n),y=c(0,tTotal),xlim=c(-1,n),ylim=c(0,tTotal),xlab="", ylab="",type="n",axes=FALSE)

  i<-1
  while (i<n) {
    dummy<-as.integer(runif(1,1,n))
    if(!is.element(dummy,coal[,2])) {
      coal[i,2]<-dummy
      i<-i+1
    } 
  }

  for(i in 2:(2*n-1)) {
    mVector<-vector(mode = "numeric", length = i-1)
    mVector<-coal[1:(i-1),2]
    ma<-0
    mi<-0
    maind<-0
    miind<-0
    if(length(mVector[mVector<coal[i,2]])>0) ma<-max(mVector[mVector<coal[i,2]])
    if(length(mVector[mVector>coal[i,2]])>0) mi<-min(mVector[mVector>coal[i,2]])

    if(ma) maind<- match(coal[coal[,2]==ma,2], coal[,2])
    if(mi) miind<- match(coal[coal[,2]==mi,2], coal[,2])
    m<-max(maind,miind)

    if(m) coal2[i,]<-coal[m,]
  }

  arrows(coal[2:(2*n-1),2], coal[2:(2*n-1),1], coal2[2:(2*n-1),2], coal2[2:(2*n-1),1], length=0)


  if(scale) {
    if(coal[1,2]>=n/2) {
      arrows(c(0,0),c(0,1),c(0,0),c(1,0), length=0.1, col="red")
      text(n/20,0.5,expression(paste(2,N)), col="red", cex=2)
    } else {
      arrows(c(n,n),c(0,1),c(n,n),c(1,0), length=0.1, col="red")
      text(n-n/20,0.5,expression(paste(2,N)), col="red", cex=2)
    }
  }

  if(pdf) dev.off()
}

#coalator(n=20, scale=FALSE, pdf=TRUE)
