onevalue<-function(v) {
  ans<-1
  a<-v[1]
  for(i in v) {
    if(i != a) ans = 0    
  }
  ans
}

freqSpec<-function(A) {
  ret<-0 * 1:(A[[3]]-1)
  if(length(A[[1]])) {
    for(i in 1:length(A[[1]][1,])) {
      k<-sum(A[[1]][,i])
      if(k && k<A[[3]]) ret[k]<-ret[k]+1
    }
  }
  ret
}

plotSFS<-function(A) {
  N<-A[[3]]

  sfs<-freqSpec(A)
  if(sum(sfs)) sfs<-sfs/sum(sfs)

  neutral<-1/((1:(N-1))*sum(1/(1:(N-1))))
  
  plot( 1:(N-1), sfs, type="h", ylim=c(0,max(sfs,neutral)), xlab="i", ylab=expression(paste(S[i])), col="red")
  points(1:(N-1), neutral, col="blue")

  legend( "topright", legend=c("simul", "neutral"), col=c("red", "blue"), lty=1, bg="white" )
}

plotA<-function(A, ...) {
  S<-0
  if(length(A[[1]]))
    S<-length(A[[1]][1,])
  N<-A[[3]]

  for(i in 1:N) {
    lines(c(0, 1), c(i,i))
  }
  if(S>0) {
    for(i in 1:N) {
      for(j in 1:S) {
        if(A[[1]][i,j]) {
          points(A[[2]][j], i, pch=19, cex=20/N,... )
        }
      }
    }
  }
}

h<-function(N,s,i) {
  (1-(1-s)^i)/(1-(1-s)^N)
}

trans<-function(N,s,i) {
  a<-c(0,0,0)
  a[1]<-i*(N-i)*h(N,s,i-1)/h(N,s,i)
  a[2]<-(i^2 + (N-i)^2)*h(N,s,i)/h(N,s,i)
  a[3]<-(N-i)*i*(1-s)*h(N,s,i+1)/h(N,s,i)
  sample(1:3,1,prob=a)+i-1  
}

createNeutralA<-function(N, S, u) {
  if(S==0) {
    S<-rpois(1,2*N*u*log(N-1))
  }
  if(S==0) S=1
  # positions of SNPs
  x<-sort(c(runif(S)), index.return=TRUE)$x

  A<-matrix(0, ncol=S, nrow=N)
  freq<-sample(1:(N-1), S, replace=TRUE, prob=1/(1:(N-1)))

  for(i in 1:N) {
    for(j in 1:S) {
      A[i,j]<-rbinom(n=1, size=1, p=freq[j]/N)
      if(A[i,j]) freq[j]<-freq[j]-1
    }
  }
  list(A,x,N)
}

recombination<-function(A, i, j, brea) {
  if(length(A[[2]])) {
    for(k in 1:(length(A[[2]]))) {
      if(A[[2]][k]>brea) {
        tmp<-A[[1]][i,k]
        A[[1]][i,k]<-A[[1]][j,k]
        A[[1]][j,k]<-tmp
      }
    }
  }
  sprintf("recombination between %d and %d at position %f", i, j, brea)
  A
}

mutation<-function(A, i, sites) {
  new<-matrix(0, ncol=length(sites), nrow=A[[3]])
  new[i,]<-1 + 0*(1:length(sites))
  if(length(A[[1]])) {
    A[[1]]<-cbind(A[[1]], new)
  } else {
    A[[1]]<-new
  }
  A[[2]]<-append(A[[2]], sites)
  sprintf("new mutations on sequence %d", i)
  A
}

resampling<-function(A, i, j) {
  if(length(A[[1]])) {
    A[[1]][j,]<-A[[1]][i,] 
  }
  sprintf("resampling between %d and %d", i, j)
  A
}

deleteFixed<-function(A) {
  N<-A[[3]]
  S<-0
  if(length(A[[1]])) S<-length(A[[1]][1,])
  i<-1
  while(i<=S) {
    if(sum(A[[1]][,i])==N || sum(A[[1]][,i])== 0 ) {
      if(i==1 && i<S) {
        A[[1]]<-matrix(A[[1]][,2:S], nrow=N, ncol=S-1)
        A[[2]]<-A[[2]][2:S]
      } else if(i==S && i>1) {
        A[[1]]<-matrix(A[[1]][,1:(S-1)], nrow=N, ncol=S-1)
        A[[2]]<-A[[2]][1:(S-1)]
      } else if(i==S && i==1) {
        A[[1]]<-matrix(0, ncol=0, nrow=0)
        A[[2]]<-vector(length=0)
      } else {
        A[[1]]<-cbind(A[[1]][,1:(i-1)], A[[1]][,(i+1):S])
        A[[2]]<-append(A[[2]][1:(i-1)], A[[2]][(i+1):S])
      }
      S<-S-1
      i<-i-1
    }
    i<-i+1
  }
  A
}

