\name{seqEvoMullersRatchet}

\alias{seqEvoMullersRatchet}

\title{Sequence evolution under Muller's ratchet}
\description{Simulation of sequence diversity of deleterious mutations under Muller's ratchet}

\usage{
seqEvoMullersRatchet( N=10, s=0.03, u=0.1, stoptime=20, wait=0, seed=0, 
                      seq=TRUE, sfs=FALSE )
}

\arguments{
   \item{N}{population size}
   \item{s}{selective desadvantage of each new mutation}
   \item{u}{deleterious mutation probability per line for the segment}
   \item{stoptime}{number of generations to simulate}
   \item{wait}{amount of time to wait between plots in seconds; a negative number refers to an input before the next plot}
   \item{seq}{if TRUE show all sequences as graphical output}
   \item{sfs}{if TRUE show site frequency spectrum as graphical output}
   \item{seed}{seed for the random number generator; if seed=0 the system time is used}
}

\details{
In Muller's ratchet lines are grouped into classes according to the number of deleterious mutations they carry. Since there is no recombination, the class carrying the least number of deleterious mutations is eventually lost. This is a click in the ratchet. 
}

\value{
none; just graphical output and the minimal number of mutations
}

\references{\url{http://www.zi.biologie.uni-muenchen.de/~pfaffelhuber/teaching/popgenCourse.html}}
\author{Peter Pfaffelhuber}

\examples{
seqEvoMullersRatchet(N=10, s=0.1, u=0.2, wait=0, stoptime=10, seed=0) 
}

\keyword{distribution}
