\name{wf.model}

\alias{wf.model}

\title{Graphical representation of a Wright-Fisher model}
\description{Graphical representation of a Wright-Fisher model}

\usage{
wf.model( N=10, mark=NULL, T=13, pdf=FALSE, time=TRUE, markMRCA=FALSE, 
          seed=0, tangled=TRUE, untangled=TRUE, col="green", cex=2 )  
}

\arguments{
   \item{N}{population size}
   \item{mark}{set of ancestral lines which should be marked}
   \item{T}{number of generations to be plotted}
   \item{pdf}{if TRUE, a pdf is created as output}
   \item{time}{if TRUE the generations are plotted as number left to the graphical representation}
   \item{markMRCA}{if TRUE, the MRCA of the sample 'mark' is marked}
   \item{seed}{seed for the random number generator; if seed=0 the system time is used}
   \item{tangled}{if TRUE the tangled version of the Wright-Fisher model is shown}
   \item{untangled}{if TRUE the untangled version of the Wright-Fisher model is shown}
   \item{col}{color of marked lines}
   \item{cex}{expansion factor for marked lines}
}

\details{
You will see the classical representation of a Wright-Fisher model. In generation n+1 each (haploid) individual chooses one parent from generation n purely at random. By common ancestry lines may coalesce.}

\value{
none; just graphical output is produced
}

\references{\url{http://www.zi.biologie.uni-muenchen.de/~pfaffelhuber/teaching/popgenCourse.html}}
\author{Peter Pfaffelhuber}

\examples{
wf.model( N=10, mark=NULL, T=13, pdf=FALSE, time=TRUE, markMRCA=FALSE, 
          seed=0, tangled=TRUE, untangled=TRUE ) 
}

\keyword{distribution}
